Index: trunk/src/world_entities/space_ships/hover.cc
===================================================================
--- trunk/src/world_entities/space_ships/hover.cc	(revision 9656)
+++ trunk/src/world_entities/space_ships/hover.cc	(revision 9869)
@@ -34,14 +34,16 @@
 #include "debug.h"
 
-CREATE_FACTORY(Hover, CL_HOVER);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Hover, CL_HOVER);
+CREATE_FACTORY(Hover);
 
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(Hover, CL_HOVER,
-                        addMethod("hasPlayer", ExecutorLua0ret<Playable,bool>(&Playable::hasPlayer))
+CREATE_SCRIPTABLE_CLASS(Hover,
+			addMethod("hasPlayer", Executor0ret<Playable, lua_State*,bool>(&Playable::hasPlayer))
                         //Coordinates
-                        ->addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
-                        ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
-                        ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
-                        ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
+			    ->addMethod("setAbsCoor", Executor3<PNode, lua_State*,float,float,float>(&PNode::setAbsCoor))
+			    ->addMethod("getAbsCoorX", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorX))
+			    ->addMethod("getAbsCoorY", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorY))
+			    ->addMethod("getAbsCoorZ", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorZ))
                        );
 
@@ -98,5 +100,5 @@
   Weapon* wpLeft = new TestGun(1);
   wpLeft->setName("testGun Left");
-  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_HYPERBLASTER));
+  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate("Hyperblaster"));
 
   cannon->setName("BFG");
@@ -123,5 +125,5 @@
 
   //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_HOVER, "Hover");
+  this->registerObject(this, Hover::_objectList);
   this->toReflectionList();
 
Index: trunk/src/world_entities/space_ships/hover.h
===================================================================
--- trunk/src/world_entities/space_ships/hover.h	(revision 9656)
+++ trunk/src/world_entities/space_ships/hover.h	(revision 9869)
@@ -15,4 +15,5 @@
 class Hover : public Playable
 {
+  ObjectListDeclaration(Hover);
   public:
 
Index: trunk/src/world_entities/space_ships/space_ship.cc
===================================================================
--- trunk/src/world_entities/space_ships/space_ship.cc	(revision 9656)
+++ trunk/src/world_entities/space_ships/space_ship.cc	(revision 9869)
@@ -26,6 +26,6 @@
 #include "weapons/cannon.h"
 
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 
 #include "util/loading/factory.h"
@@ -53,19 +53,21 @@
 
 
-
-CREATE_FACTORY(SpaceShip, CL_SPACE_SHIP);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(SpaceShip, CL_SPACE_SHIP);
+CREATE_FACTORY(SpaceShip);
+
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(SpaceShip, CL_SPACE_SHIP,
-                        addMethod("hasPlayer", ExecutorLua0ret<Playable,bool>(&Playable::hasPlayer))
-                        ->addMethod("fire", ExecutorLua1<Playable, bool>(&Playable::fire))
-                        ->addMethod("loadModel", ExecutorLua2<WorldEntity,const std::string& ,float>(&WorldEntity::loadModel2))
-                        ->addMethod("setName", ExecutorLua1<BaseObject,const std::string&>(&BaseObject::setName))
-                        ->addMethod("hide", ExecutorLua0<WorldEntity>(&WorldEntity::hide))
-                        ->addMethod("unhide", ExecutorLua0<WorldEntity>(&WorldEntity::unhide))
-                       //Coordinates
-                        ->addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
-                        ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
-                        ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
-                        ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
+CREATE_SCRIPTABLE_CLASS(SpaceShip,
+                        addMethod("hasPlayer", Executor0ret<Playable, lua_State*,bool>(&Playable::hasPlayer))
+                        ->addMethod("fire", Executor1<Playable, lua_State*, bool>(&Playable::fire))
+                        ->addMethod("loadModel", Executor2<WorldEntity, lua_State*,const std::string& ,float>(&WorldEntity::loadModel2))
+                        ->addMethod("setName", Executor1<BaseObject, lua_State*,const std::string&>(&BaseObject::setName))
+                        ->addMethod("hide", Executor0<WorldEntity, lua_State*>(&WorldEntity::hide))
+                        ->addMethod("unhide", Executor0<WorldEntity, lua_State*>(&WorldEntity::unhide))
+                        //Coordinates
+                        ->addMethod("setAbsCoor", Executor3<PNode, lua_State*,float,float,float>(&PNode::setAbsCoor))
+                        ->addMethod("getAbsCoorX", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorX))
+                        ->addMethod("getAbsCoorY", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorY))
+                        ->addMethod("getAbsCoorZ", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorZ))
                        );
 
@@ -116,6 +118,6 @@
 void SpaceShip::init()
 {
-//  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_SPACE_SHIP, "SpaceShip");
+  //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
+  this->registerObject(this, SpaceShip::_objectList);
 
   PRINTF(4)("SPACESHIP INIT\n");
@@ -145,5 +147,5 @@
   controlVelocityY = 150;
   shipInertia = 1.5;
-//  cycle = 0.0;
+  //  cycle = 0.0;
 
   this->setHealthMax(100);
@@ -156,14 +158,14 @@
   this->pitchDir = this->getAbsDir();
 
-//   GLGuiButton* button = new GLGuiPushButton();
-//    button->show();
-//    button->setLabel("orxonox");
-//    button->setBindNode(this);
-//     GLGuiBar* bar = new GLGuiBar();
-//     bar->show();
-//     bar->setValue(7.0);
-//     bar->setMaximum(10);
-//     bar->setSize2D( 20, 100);
-//     bar->setAbsCoor2D( 10, 200);
+  //   GLGuiButton* button = new GLGuiPushButton();
+  //    button->show();
+  //    button->setLabel("orxonox");
+  //    button->setBindNode(this);
+  //     GLGuiBar* bar = new GLGuiBar();
+  //     bar->show();
+  //     bar->setValue(7.0);
+  //     bar->setMaximum(10);
+  //     bar->setSize2D( 20, 100);
+  //     bar->setAbsCoor2D( 10, 200);
 
   //add events to the eventlist
@@ -200,13 +202,13 @@
   this->getWeaponManager().setSlotPosition(5, Vector(-1.5, -.5, -.5));
   this->getWeaponManager().setSlotDirection(5, Quaternion(+M_PI_4*.5-M_PI, Vector(1,0,0)));
-//
-   this->getWeaponManager().setSlotPosition(6, Vector(-1, 0.0, 0));
-   this->getWeaponManager().setSlotCapability(6, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-   //
-//   this->getWeaponManager().setSlotPosition(8, Vector(-2.5, -0.3, -2.0));
-//   this->getWeaponManager().setSlotDirection(8, Quaternion(-M_PI, Vector(1,0,0)));
-//
-//   this->getWeaponManager().setSlotPosition(9, Vector(-2.5, -0.3, 2.0));
-//   this->getWeaponManager().setSlotDirection(9, Quaternion(+M_PI, Vector(1,0,0)));:
+  //
+  this->getWeaponManager().setSlotPosition(6, Vector(-1, 0.0, 0));
+  this->getWeaponManager().setSlotCapability(6, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  //
+  //   this->getWeaponManager().setSlotPosition(8, Vector(-2.5, -0.3, -2.0));
+  //   this->getWeaponManager().setSlotDirection(8, Quaternion(-M_PI, Vector(1,0,0)));
+  //
+  //   this->getWeaponManager().setSlotPosition(9, Vector(-2.5, -0.3, 2.0));
+  //   this->getWeaponManager().setSlotDirection(9, Quaternion(+M_PI, Vector(1,0,0)));:
 
   this->getWeaponManager().getFixedTarget()->setParent(this);
@@ -310,5 +312,4 @@
 void SpaceShip::collidesWith(WorldEntity* entity, const Vector& location)
 {
-
 }
 
@@ -332,5 +333,5 @@
 
   if( ( xMouse != 0 || yMouse != 0 ) && this->getOwner() == SharedNetworkData::getInstance()->getHostID() )
-   {
+  {
     if (xMouse > controlVelocityX) xMouse = controlVelocityX;
     else if (xMouse < -controlVelocityX) xMouse = -controlVelocityX;
@@ -342,13 +343,13 @@
     mouseDir *= (Quaternion(-M_PI/4*xMouse*mouseSensitivity, Vector(0,1,0))*Quaternion(-M_PI/4*yMouse*mouseSensitivity*yInvert, Vector(0,0,1))*pitchDir);
     xMouse = yMouse = 0;
-   }
-
-
-//   if( this != State::getPlayer()->getControllable())
-//     return;
+  }
+
+
+  //   if( this != State::getPlayer()->getControllable())
+  //     return;
 
   // spaceship controlled movement fire(bool bF){ this->bFire = bF;}
   //if (this->getOwner() == this->getHostID())
-    this->calculateVelocity(time);
+  this->calculateVelocity(time);
 
 
@@ -363,8 +364,8 @@
 
   //orient the spaceship in direction of the mouse
-   rotQuat = Quaternion::quatSlerp( this->getAbsDir(), mouseDir, 0.5);//fabsf(time)*shipInertia);
-   if (this->getAbsDir().distance(rotQuat) > 0.00000000000001)
+  rotQuat = Quaternion::quatSlerp( this->getAbsDir(), mouseDir, 0.5);//fabsf(time)*shipInertia);
+  if (this->getAbsDir().distance(rotQuat) > 0.00000000000001)
     this->setAbsDir( rotQuat);
-   //this->setAbsDirSoft(mouseDir,5);
+  //this->setAbsDirSoft(mouseDir,5);
 
   // this is the air friction (necessary for a smooth control)
@@ -388,5 +389,5 @@
   this->shiftCoor(move);
 
-//   PRINTF(0)("id of %s is: %i\n", this->getName(), this->getOMListNumber());
+  //   PRINTF(0)("id of %s is: %i\n", this->getName(), this->getOMListNumber());
 
 }
@@ -409,26 +410,26 @@
 
   if( this->bUp )
-   {
-     //this->shiftCoor(this->getAbsDirX());
-      //accel += (this->getAbsDirX())*2;
-      accel += (this->getAbsDirX())*acceleration;
-
-   }
+  {
+    //this->shiftCoor(this->getAbsDirX());
+    //accel += (this->getAbsDirX())*2;
+    accel += (this->getAbsDirX())*acceleration;
+
+  }
 
   if( this->bDown )
-   {
-     //this->shiftCoor((this->getAbsDirX())*-1);
-     //accel -= (this->getAbsDirX())*2;
+  {
+    //this->shiftCoor((this->getAbsDirX())*-1);
+    //accel -= (this->getAbsDirX())*2;
     //if(velocity.len() > 50)
-     accel -= (this->getAbsDirX())*0.5*acceleration;
-
-
-
-   }
+    accel -= (this->getAbsDirX())*0.5*acceleration;
+
+
+
+  }
 
   if( this->bLeft/* > -this->getRelCoor().z*2*/)
   {
     this->shiftDir(Quaternion(time, Vector(0,1,0)));
-//    accel -= rightDirection;
+    //    accel -= rightDirection;
     //velocityDir.normalize();
     //rot +=Vector(1,0,0);
@@ -449,5 +450,5 @@
   {
     mouseDir *= Quaternion(-time*2, Vector(1,0,0));
-//    accel -= rightDirection;
+    //    accel -= rightDirection;
     //velocityDir.normalize();
     //rot +=Vector(1,0,0);
@@ -467,5 +468,5 @@
     this->shiftDir(Quaternion(time, Vector(0,0,1)));
 
-//    accel += upDirection;
+    //    accel += upDirection;
     //velocityDir.normalize();
     //rot += Vector(0,0,1);
@@ -495,7 +496,7 @@
 
   if( event.type == KeyMapper::PEV_LEFT)
-      this->bRollL = event.bPressed;
+    this->bRollL = event.bPressed;
   else if( event.type == KeyMapper::PEV_RIGHT)
-      this->bRollR = event.bPressed;
+    this->bRollR = event.bPressed;
   else if( event.type == KeyMapper::PEV_FORWARD)
     this->bUp = event.bPressed; //this->shiftCoor(0,.1,0);
Index: trunk/src/world_entities/space_ships/space_ship.h
===================================================================
--- trunk/src/world_entities/space_ships/space_ship.h	(revision 9656)
+++ trunk/src/world_entities/space_ships/space_ship.h	(revision 9869)
@@ -19,4 +19,5 @@
 class SpaceShip : public Playable
 {
+  ObjectListDeclaration(SpaceShip);
 
   public:
@@ -36,5 +37,5 @@
     virtual void postSpawn();
     virtual void leftWorld();
-    
+
     virtual void destroy(WorldEntity* killer);
     virtual void respawn();
Index: trunk/src/world_entities/space_ships/spacecraft_2d.cc
===================================================================
--- trunk/src/world_entities/space_ships/spacecraft_2d.cc	(revision 9656)
+++ trunk/src/world_entities/space_ships/spacecraft_2d.cc	(revision 9869)
@@ -30,6 +30,6 @@
 
 #include "graphics_engine.h"
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 
 #include "debug.h"
@@ -38,16 +38,18 @@
 
 
-CREATE_FACTORY(Spacecraft2D, CL_SPACECRAFT_2D);
-
-
-CREATE_SCRIPTABLE_CLASS(Spacecraft2D, CL_SPACECRAFT_2D,
-                        addMethod("hasPlayer", ExecutorLua0ret<Playable,bool>(&Playable::hasPlayer))
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Spacecraft2D, CL_SPACECRAFT_2D);
+CREATE_FACTORY(Spacecraft2D);
+
+CREATE_SCRIPTABLE_CLASS(Spacecraft2D,
+			addMethod("hasPlayer", Executor0ret<Playable, lua_State*,bool>(&Playable::hasPlayer))
                         //Coordinates
-                        ->addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
-                        ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
-                        ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
-                        ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
-                        ->addMethod("setAirFriction", ExecutorLua1<Spacecraft2D, float>(&Spacecraft2D::setAirFriction))
+			    ->addMethod("setAbsCoor", Executor3<PNode, lua_State*,float,float,float>(&PNode::setAbsCoor))
+			    ->addMethod("getAbsCoorX", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorX))
+			    ->addMethod("getAbsCoorY", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorY))
+			    ->addMethod("getAbsCoorZ", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorZ))
+			    ->addMethod("setAirFriction", Executor1<Spacecraft2D, lua_State*, float>(&Spacecraft2D::setAirFriction))
                        );
+
 
 
@@ -85,12 +87,12 @@
 
   //weapons:
-  Weapon* wpRight = dynamic_cast<Weapon*>(Factory::fabricate(CL_LASER_CANNON));
+  Weapon* wpRight = dynamic_cast<Weapon*>(Factory::fabricate("LaserCannon"));
   wpRight->setName("Cannon_Right");
-  Weapon* wpLeft = dynamic_cast<Weapon*>(Factory::fabricate(CL_LASER_CANNON));
+  Weapon* wpLeft = dynamic_cast<Weapon*>(Factory::fabricate("LaserCannon"));
   wpLeft->setName("Cannon_Left");
 
-  Weapon* turretLeft = dynamic_cast<Weapon*>(Factory::fabricate(CL_BOOMERANG_GUN));
+  Weapon* turretLeft = dynamic_cast<Weapon*>(Factory::fabricate("BoomerangGun"));
   wpRight->setName("Turret_Left");
-  Weapon* turretRight = dynamic_cast<Weapon*>(Factory::fabricate(CL_BOOMERANG_GUN));
+  Weapon* turretRight = dynamic_cast<Weapon*>(Factory::fabricate("BoomerangGun"));
   wpLeft->setName("Turret_Right");
 
@@ -125,5 +127,5 @@
 {
   //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_SPACECRAFT_2D, "Spacecraft2D");
+  this->registerObject(this, Spacecraft2D::_objectList);
 
   this->setSupportedPlaymodes(Playable::Full3D | Playable::Horizontal );
Index: trunk/src/world_entities/space_ships/spacecraft_2d.h
===================================================================
--- trunk/src/world_entities/space_ships/spacecraft_2d.h	(revision 9656)
+++ trunk/src/world_entities/space_ships/spacecraft_2d.h	(revision 9869)
@@ -16,4 +16,5 @@
 class Spacecraft2D : public Playable
 {
+  ObjectListDeclaration(Spacecraft2D);
   public:
     Spacecraft2D(const std::string& fileName);
Index: trunk/src/world_entities/space_ships/turbine_hover.cc
===================================================================
--- trunk/src/world_entities/space_ships/turbine_hover.cc	(revision 9656)
+++ trunk/src/world_entities/space_ships/turbine_hover.cc	(revision 9869)
@@ -29,10 +29,12 @@
 
 #include "graphics_engine.h"
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 
 #include "debug.h"
 
-CREATE_FACTORY(TurbineHover, CL_TURBINE_HOVER);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(TurbineHover, CL_TURBINE_HOVER);
+CREATE_FACTORY(TurbineHover);
 
 /**
@@ -101,5 +103,5 @@
 {
   //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_TURBINE_HOVER, "TurbineHover");
+  this->registerObject(this, TurbineHover::_objectList);
 
   this->setSupportedPlaymodes(Playable::Full3D | Playable::Horizontal | Playable::Vertical);
Index: trunk/src/world_entities/space_ships/turbine_hover.h
===================================================================
--- trunk/src/world_entities/space_ships/turbine_hover.h	(revision 9656)
+++ trunk/src/world_entities/space_ships/turbine_hover.h	(revision 9869)
@@ -18,65 +18,66 @@
 class TurbineHover : public Playable
 {
-  public:
-    TurbineHover(const std::string& fileName);
-    TurbineHover(const TiXmlElement* root = NULL);
-    virtual ~TurbineHover();
+  ObjectListDeclaration(TurbineHover);
+public:
+  TurbineHover(const std::string& fileName);
+  TurbineHover(const TiXmlElement* root = NULL);
+  virtual ~TurbineHover();
 
-    void setBoostColor(const Color& color);
+  void setBoostColor(const Color& color);
 
-    virtual void loadParams(const TiXmlElement* root);
-    virtual void setPlayDirection(const Quaternion& rot, float speed = 0.0f);
-    virtual void enter();
-    virtual void leave();
+  virtual void loadParams(const TiXmlElement* root);
+  virtual void setPlayDirection(const Quaternion& rot, float speed = 0.0f);
+  virtual void enter();
+  virtual void leave();
 
-    virtual void setTeam(int teamID);
+  virtual void setTeam(int teamID);
 
-    virtual void postSpawn();
-    virtual void leftWorld();
-    virtual void respawn();
+  virtual void postSpawn();
+  virtual void leftWorld();
+  virtual void respawn();
 
-    virtual void collidesWith(WorldEntity* entity, const Vector& location);
-    virtual void tick(float dt);
-    virtual void draw() const;
+  virtual void collidesWith(WorldEntity* entity, const Vector& location);
+  virtual void tick(float dt);
+  virtual void draw() const;
 
-    virtual void process(const Event &event);
+  virtual void process(const Event &event);
 
-  private:
-    void init();
-    void movement(float dt);
+private:
+  void init();
+  void movement(float dt);
 
-  private:
-    bool                  bForward;           //!< forward button pressed.
-    bool                  bBackward;          //!< backward button pressed.
-    bool                  bLeft;              //!< left button pressed.
-    bool                  bRight;             //!< right button pressed.
-    bool                  bAscend;            //!< ascend button pressed.
-    bool                  bDescend;           //!< descend button presses.
+private:
+  bool                  bForward;           //!< forward button pressed.
+  bool                  bBackward;          //!< backward button pressed.
+  bool                  bLeft;              //!< left button pressed.
+  bool                  bRight;             //!< right button pressed.
+  bool                  bAscend;            //!< ascend button pressed.
+  bool                  bDescend;           //!< descend button presses.
 
-    int                   yInvert;
-    float                 mouseSensitivity;   //!< the mouse sensitivity
+  int                   yInvert;
+  float                 mouseSensitivity;   //!< the mouse sensitivity
 
-    PNode                 wingNodeLeft;
-    PNode                 wingNodeRight;
-    PNode                 rotorNodeLeft;
-    PNode                 rotorNodeRight;
+  PNode                 wingNodeLeft;
+  PNode                 wingNodeRight;
+  PNode                 rotorNodeLeft;
+  PNode                 rotorNodeRight;
 
-    PNode                 cameraNode;
-    float                 cameraLook;
-    float                 rotation;
+  PNode                 cameraNode;
+  float                 cameraLook;
+  float                 rotation;
 
-   // Vector                velocity;           //!< the velocity of the TurbineHover.
-    Quaternion            direction;          //!< the direction of the TurbineHover.
-    float                 travelSpeed;        //!< the current speed of the Hove (to make soft movement)
-    float                 acceleration;       //!< the acceleration of the TurbineHover.
-    float                 airFriction;        //!< AirFriction.
+  // Vector                velocity;           //!< the velocity of the TurbineHover.
+  Quaternion            direction;          //!< the direction of the TurbineHover.
+  float                 travelSpeed;        //!< the current speed of the Hove (to make soft movement)
+  float                 acceleration;       //!< the acceleration of the TurbineHover.
+  float                 airFriction;        //!< AirFriction.
 
-    float                 rotorSpeed;         //!< the speed of the rotor.
-    float                 rotorCycle;         //!< The Cycle the rotor is in.
+  float                 rotorSpeed;         //!< the speed of the rotor.
+  float                 rotorCycle;         //!< The Cycle the rotor is in.
 
-    float                 airViscosity;
+  float                 airViscosity;
 
-    ParticleEmitter*      burstEmitter[2];
-    ParticleSystem*       burstSystem;
+  ParticleEmitter*      burstEmitter[2];
+  ParticleSystem*       burstSystem;
 };
 
Index: trunk/src/world_entities/spawning_point.cc
===================================================================
--- trunk/src/world_entities/spawning_point.cc	(revision 9656)
+++ trunk/src/world_entities/spawning_point.cc	(revision 9869)
@@ -22,6 +22,4 @@
 #include "world_entity.h"
 
-#include "class_list.h"
-
 #include "compiler.h"
 
@@ -35,6 +33,7 @@
 #include "converter.h"
 
-CREATE_FACTORY( SpawningPoint, CL_SPAWNING_POINT );
-
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(SpawningPoint, CL_SPAWNING_POINT);
+CREATE_FACTORY( SpawningPoint);
 /**
  *  constructor
@@ -52,5 +51,5 @@
 void SpawningPoint::init()
 {
-  this->setClassID(CL_SPAWNING_POINT, "SpawningPoint");
+  this->registerObject(this, SpawningPoint::_objectList);
   PRINTF(0)("Created SpawningPoint\n");
 
@@ -84,5 +83,5 @@
   /* load teamId */
   LoadParam(root, "teamId", this, SpawningPoint, setTeamId)
-      .describe("sets teamId");
+  .describe("sets teamId");
 }
 
@@ -108,12 +107,9 @@
 void SpawningPoint::spawn(Playable* entity)
 {
-  const std::list<BaseObject*> * list = ClassList::getList( CL_PLAYABLE );
-
   bool found = false;
 
-  if ( !list )
-    return;
-
-  for ( std::list<BaseObject*>::const_iterator it = list->begin(); it != list->end(); it++ )
+  for (ObjectList<Playable>::const_iterator it = Playable::objectList().begin();
+       it != Playable::objectList().end();
+       ++it)
   {
     if ( *it == entity )
@@ -162,12 +158,9 @@
       this->spawn(it->entity);
 
-      const std::list<BaseObject*> * list = ClassList::getList( CL_PLAYABLE );
-
       bool found = false;
 
-      if ( !list )
-        return;
-
-      for ( std::list<BaseObject*>::const_iterator it2 = list->begin(); it2 != list->end(); it2++ )
+      for (ObjectList<Playable>::const_iterator it2 = Playable::objectList().begin();
+           it2 != Playable::objectList().end();
+           ++it2)
       {
         if ( *it2 == it->entity )
@@ -202,6 +195,5 @@
  */
 void SpawningPoint::draw() const
-{
-}
+{}
 
 void SpawningPoint::sendRespawnMessage( int uniqueId )
@@ -243,16 +235,13 @@
   Playable      * playable = NULL;
 
-  const std::list<BaseObject*> * list = ClassList::getList( CL_SPAWNING_POINT );
-
-  if ( list )
-  {
-    for ( std::list<BaseObject*>::const_iterator it = list->begin(); it != list->end(); it++ )
-    {
-      PRINTF(0)("%d:%d\n", dynamic_cast<SpawningPoint*>(*it)->getUniqueID(), spUniqueId);
-      if ( dynamic_cast<SpawningPoint*>(*it)->getUniqueID() == spUniqueId )
-      {
-        sp = dynamic_cast<SpawningPoint*>(*it);
-        break;
-      }
+  for (ObjectList<SpawningPoint>::const_iterator it = SpawningPoint::objectList().begin();
+       it != SpawningPoint::objectList().end();
+       ++it)
+  {
+    PRINTF(0)("%d:%d\n", (*it)->getUniqueID(), spUniqueId);
+    if ( (*it)->getUniqueID() == spUniqueId )
+    {
+      sp = (*it);
+      break;
     }
   }
@@ -264,15 +253,12 @@
   }
 
-  list = ClassList::getList( CL_PLAYABLE );
-
-  if ( list )
-  {
-    for ( std::list<BaseObject*>::const_iterator it = list->begin(); it != list->end(); it++ )
-    {
-      if ( dynamic_cast<Playable*>(*it)->getUniqueID() == uniqueId )
-      {
-        playable = dynamic_cast<Playable*>(*it);
-        break;
-      }
+  for (ObjectList<Playable>::const_iterator it = Playable::objectList().begin();
+       it != Playable::objectList().end();
+       ++it)
+  {
+    if ( (*it)->getUniqueID() == uniqueId )
+    {
+      playable = (*it);
+      break;
     }
   }
Index: trunk/src/world_entities/spawning_point.h
===================================================================
--- trunk/src/world_entities/spawning_point.h	(revision 9656)
+++ trunk/src/world_entities/spawning_point.h	(revision 9869)
@@ -42,5 +42,5 @@
  */
 class SpawningPoint : public WorldEntity {
-
+  ObjectListDeclaration(SpawningPoint);
   public:
     SpawningPoint(const TiXmlElement* root = NULL);
Index: trunk/src/world_entities/spectator.cc
===================================================================
--- trunk/src/world_entities/spectator.cc	(revision 9656)
+++ trunk/src/world_entities/spectator.cc	(revision 9869)
@@ -22,8 +22,7 @@
 #include "shared_network_data.h"
 
-CREATE_FACTORY(Spectator, CL_SPECTATOR);
-
-
-
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Spectator, CL_SPECTATOR);
+CREATE_FACTORY(Spectator);
 
 
@@ -58,5 +57,5 @@
 {
 //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_SPECTATOR, "Spectator");
+  this->registerObject(this, Spectator::_objectList);
 
   this->getWeaponManager().changeWeaponConfig(1);
@@ -89,5 +88,5 @@
   dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( false);
 
- 
+
   registerVar( new SynchronizeableBool( &bLeft, &bLeft, "bLeft", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableBool( &bRight, &bRight, "bRight", PERMISSION_OWNER ) );
@@ -161,50 +160,50 @@
 {
   Playable::tick( time );
-  
+
   if( ( xMouse != 0 || yMouse != 0 ) && this->getOwner() == SharedNetworkData::getInstance()->getHostID() )
   {
     xMouse *= time / 10;
     yMouse *= time / 10;
-    
+
     angleX -= xMouse;
     angleY -= yMouse;
-    
+
     if ( angleY > 2.05 )
       angleY = 2.05;
-    
+
     if ( angleY < -1.15 )
       angleY = -1.15;
-    
+
     this->mouseDir = Quaternion( angleX, Vector( 0, 1, 0 ) ) * Quaternion( angleY, Vector( 0, 0, 1 ) );
-    
+
     xMouse = yMouse = 0;
   }
-  
+
   this->setAbsDir( this->mouseDir );
-  
+
   Vector velocity;
-  
+
   if ( this->bForward )
   {
     velocity += this->getAbsDirX();
   }
-  
+
   if ( this->bBackward )
   {
     velocity -= this->getAbsDirX();
   }
-  
+
   if ( this->bRight )
   {
     velocity += this->getAbsDirZ();
   }
-  
+
   if ( this->bLeft )
   {
     velocity -= this->getAbsDirZ();
   }
-  
+
   velocity *= 100;
-  
+
   this->shiftCoor( velocity*time );
 }
Index: trunk/src/world_entities/spectator.h
===================================================================
--- trunk/src/world_entities/spectator.h	(revision 9656)
+++ trunk/src/world_entities/spectator.h	(revision 9869)
@@ -11,4 +11,5 @@
 class Spectator : public Playable
 {
+  ObjectListDeclaration(Spectator);
 
   public:
@@ -37,5 +38,5 @@
     bool                  bForward;
     bool                  bBackward;
-    
+
     float                 xMouse;             //!< mouse moved in x-Direction
     float                 yMouse;             //!< mouse moved in y-Direction
Index: trunk/src/world_entities/terrain.cc
===================================================================
--- trunk/src/world_entities/terrain.cc	(revision 9656)
+++ trunk/src/world_entities/terrain.cc	(revision 9869)
@@ -18,9 +18,9 @@
 #include "terrain.h"
 
+#include "util/loading/resource_manager.h"
 #include "util/loading/load_param.h"
 #include "util/loading/factory.h"
 #include "spatial_separation.h"
 
-#include "util/loading/resource_manager.h"
 #include "model.h"
 #include "network_game_manager.h"
@@ -32,8 +32,9 @@
 
 #include "state.h"
-
-
-
-CREATE_FACTORY(Terrain, CL_TERRAIN);
+#include "debug.h"
+
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Terrain, CL_TERRAIN);
+CREATE_FACTORY(Terrain);
 
 /**
@@ -88,12 +89,8 @@
 Terrain::~Terrain ()
 {
-  if (objectList)
-    glDeleteLists(this->objectList, 1);
+  if (modelList)
+    glDeleteLists(this->modelList, 1);
   if( this->ssp)
     delete ssp;
-  if (this->vegetation)
-  {
-    ResourceManager::getInstance()->unload(this->vegetation);
-  }
 
   if(this->heightMap)
@@ -104,9 +101,9 @@
 void Terrain::init()
 {
-  this->setClassID(CL_TERRAIN, "Terrain");
+  this->registerObject(this, Terrain::_objectList);
   this->toList(OM_ENVIRON_NOTICK);
   this->toReflectionList();
 
-  this->objectList = 0;
+  this->modelList = 0;
   this->ssp = NULL;
   this->vegetation = NULL;
@@ -147,6 +144,6 @@
   this->heightMap = NULL;
 
-  std::string hmName = ResourceManager::getFullName(heightMapFile);
-  std::string hmColorName = ResourceManager::getFullName(colorMap);
+  std::string hmName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(heightMapFile);
+  std::string hmColorName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(colorMap);
 
 
@@ -180,9 +177,10 @@
   PRINTF(4)("loadVegetation: %s\n", vegetationFile.c_str());
   if (this->vegetation)
-    ResourceManager::getInstance()->unload(this->vegetation, RP_LEVEL);
+    this->vegetation = 0;
   if (!vegetationFile.empty())
   {
     PRINTF(4)("fetching %s\n", vegetationFile.c_str());
-    this->vegetation = dynamic_cast<Model*>(ResourceManager::getInstance()->load(vegetationFile, OBJ, RP_CAMPAIGN));
+    this->loadModel(vegetationFile, 1.0, 2);
+    this->vegetation = this->getModel(2);
   }
   else
@@ -206,6 +204,6 @@
   //glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
 
-  if (this->objectList)
-    glCallList(this->objectList);
+  if (this->modelList)
+    glCallList(this->modelList);
   else if (this->getModel())
     this->getModel()->draw();
@@ -256,6 +254,6 @@
   if (debugTerrain == TERRAIN_DAVE)
   {
-    objectList = glGenLists(1);
-    glNewList (objectList, GL_COMPILE);
+    modelList = glGenLists(1);
+    glNewList (modelList, GL_COMPILE);
 
     glColor3f(1.0,0,0);
Index: trunk/src/world_entities/terrain.h
===================================================================
--- trunk/src/world_entities/terrain.h	(revision 9656)
+++ trunk/src/world_entities/terrain.h	(revision 9869)
@@ -12,5 +12,4 @@
 
 #include "world_entity.h"
-#include "vector.h"
 
 // FORWARD DECLARATION
@@ -26,4 +25,5 @@
 class Terrain : public WorldEntity
 {
+  ObjectListDeclaration(Terrain);
 
  public:
@@ -52,5 +52,5 @@
  private:
    Model*              vegetation;
-   int                 objectList;
+   int                 modelList;
 
    HeightMap*          heightMap;
